#include <amxmodx>
#include <amxmisc>
#include <reapi>

new bool:g_PauseStatus, g_PausePlus

public plugin_init()
{
	register_plugin("Pause_Plus", "1.0", "Alt")
	register_event("HLTV", "NewRound", "a", "1=0", "2=0")
	g_PausePlus = register_cvar("amx_pauseplus", "1")
	register_clcmd("say", "Cmd_SayHook")
	g_PauseStatus = false
}

public NewRound()
{
	if(task_exists(12999))
	{
		g_PauseStatus = false
		remove_task(12999)
		Message_Pause_Close()
	}
}

public client_disconnected(id)
{
	if((get_playersnum(1) < 3) && task_exists(12999))
	{
		g_PauseStatus = false
		remove_task(12999)
	}
}

public Cmd_SayHook(id)
{
	new arg[32]
	read_args(arg, charsmax(arg))
	remove_quotes(arg)
	if(equal(arg,"zanting") || equal(arg,"/zanting"))
	{
		if(get_pcvar_num(g_PausePlus))
		{
			if(!has_all_flags(id,"m"))
			{
				client_color(id, id, "[注意] 你没有权限使用此功能！")
				return PLUGIN_HANDLED
			}
			Cmd_Pause(id)
			return PLUGIN_HANDLED
		}
		else
		{
			client_color(id, id, "[注意] 服务器暂停功能已禁用！")
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_CONTINUE
}

public Cmd_Pause(id)
{
	new freezetime[1]
	freezetime[0] = get_cvar_num("mp_freezetime")
	new is_freezetime = get_member_game(m_bFreezePeriod)
	
	if(!freezetime[0])
	{
		g_PauseStatus = false
		if(task_exists(12999))
		{
			remove_task(12999)
			Message_Pause_Close()
		}
		client_color(id, id, "[注意] 服务器没有设置冻结时间无法暂停游戏！")
		return PLUGIN_CONTINUE
	}
	
	if(is_freezetime)
	{
		new szName[32]
		get_user_name(id, szName, charsmax(szName))
		
		if(!g_PauseStatus)
		{
			g_PauseStatus = true
			set_task(0.1, "Pause",12999,freezetime,1,"b")
			client_color(0, id, "[提示] 管理员 %s 开启游戏暂停。", szName)
			return PLUGIN_CONTINUE
		}
		else
		{
			g_PauseStatus = false
			if(task_exists(12999))
			{
				remove_task(12999)
				Message_Pause_Close()
			}
			client_color(0, id, "[提示] 管理员 %s 关闭游戏暂停。", szName)
			return PLUGIN_CONTINUE
		}
	}
	else
	{
		g_PauseStatus = false
		if(task_exists(12999))
		{
			remove_task(12999)
			Message_Pause_Close()
		}
		client_color(id, id, "[注意] 当前不在冻结时间无法暂停！")
		return PLUGIN_CONTINUE
	}
}

public Pause(iSecAmount[])
{
	new Float:lGameTime = get_gametime( )
	set_member_game(m_fRoundStartTime, lGameTime)
	set_member_game(m_fRoundStartTimeReal, lGameTime)
	set_member_game(m_iRoundTimeSecs, iSecAmount[0])
	
	Message_Pause_Open()
	Message_Pause_RoundTime()
}

Message_Pause_RoundTime()
{
    message_begin(MSG_ALL, get_user_msgid("RoundTime"))
    write_short(get_member_game(m_iRoundTimeSecs))
    message_end()
}

Message_Pause_Close()
{
	message_begin(MSG_ALL, get_user_msgid("TextMsg"))
	write_byte( print_center )
	write_string("[解除暂停] 游戏继续！！！")
	message_end()
}

Message_Pause_Open()
{
	message_begin(MSG_ALL, get_user_msgid("TextMsg"))
	write_byte(print_center)
	write_string("[游戏暂停] 等待管理员解除暂停！")
	message_end()
}

stock client_color(index, color, const msg[], any:...) 
{
	static szMessage[256]
	szMessage[0] = 0x04
	vformat(szMessage[1], charsmax(szMessage)-1, msg, 4)
	
	message_begin(index ? MSG_ONE : MSG_ALL, get_user_msgid("SayText"), {0,0,0}, index)
	write_byte(color)
	write_string(szMessage)
	message_end()
}